--[[------------------------------------------------------------
	WorldStateFrame Mover
--------------------------------------------------------------]]

local f = WorldStateAlwaysUpFrame
local db

function f:StopMoving()
	self:StopMovingOrSizing()
	db.x = self:GetLeft()
	db.y = self:GetTop()
end

function f:Lock()
	self:SetBackdropColor(1,1,1,0)
	self:EnableMouse(false)
	self.locked = true
end

function f:Unlock()
	self:SetBackdropColor(1,1,1,1)
	self:EnableMouse(true)
	self.locked = false
end

function f:ToggleLock()
	if not self.locked then
		self:Lock()
	else
		self:Unlock()
	end
end

local eventFrame = CreateFrame("Frame")
eventFrame:RegisterEvent("PLAYER_LOGIN")
eventFrame:SetScript("OnEvent", function(self)
	if not WSFMoverDB then
		WSFMoverDB = {}
	end
	db = WSFMoverDB

	f:SetBackdrop({bgFile="Interface\\Tooltips\\UI-Tooltip-Background"})
	f:SetBackdropColor(1,1,1,0)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")
	f:SetScript("OnDragStart", f.StartMoving)
	f:SetScript("OnDragStop", f.StopMoving)

	if db.x and db.y then
		f:ClearAllPoints()
		f:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", db.x, db.y)
		f:Lock()
	else
		f:Unlock()
	end

	self:UnregisterEvent("PLAYER_LOGIN")
	self:SetScript("OnEvent", nil)
end)

SLASH_WSFLOCK1 = "/wsflock"
SlashCmdList.WSFLOCK = function() f:ToggleLock() end